#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityLuckyCoinCFG.h"
std::auto_ptr<M_ActivityLuckyCoinCFG> M_ActivityLuckyCoinCFG::msSingleton(nullptr);

int M_ActivityLuckyCoinCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityLuckyCoinCFGData* M_ActivityLuckyCoinCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityLuckyCoinCFGData>& M_ActivityLuckyCoinCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityLuckyCoinCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityLuckyCoinCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityLuckyCoinCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mneedItem = element->IntAttribute("needItem");
		data.mneedCount = element->IntAttribute("needCount");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityLuckyCoinCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityLuckyCoinCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityLuckyCoinCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityLuckyCoinCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityLuckyCoinCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readInt(L, "needItem", data.mneedItem);
		LuaCfgHelper::readInt(L, "needCount", data.mneedCount);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityLuckyCoinCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityLuckyCoinCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityLuckyCoinCFG* M_ActivityLuckyCoinCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityLuckyCoinCFG());
	}
	return msSingleton.get();
}

void M_ActivityLuckyCoinCFG::Release()
{
	msSingleton.reset(nullptr);
}
